*** (Harbour/xHarbour)
REQUEST HB_LANG_PT        // CONFIGURAO DA LINGUAGEM PORTUGUS
REQUEST HB_CODEPAGE_PT850 // PARA INDEXAR CAMPOS ACENTUADOS

#include "inkey.ch"

Function Main() // TODO PROGRAMA EM xHARBOUR DEVE TER UM FUNCTION MAIN() INDICANDO O PROGRAMA PRINCIPAL
*** SETs
SET SCOREBOARD OFF // READ e MemoEdit() sem mensagems de status na linha 0 da tela 
SET DATE BRITISH   // PADRO DE DATA BRITNICO DIA/MS/ANO
SET MESSAGE TO 24  // POSICIONA AS MENSAGENS NA LINHA 24 
SET DELETED ON     // no mostra arquivos deletados
SET EPOCH TO 1980  // Y2K COMPLIANT (FIX DO BUG DO MILNIO): ANO < 80 = 2000 + ANO
SETMODE(25,80)     // TELA PADRO, 25 (0-24) linhas e 80 (0-79) colunas
SET CONFIRM ON     // CONFIRMA CAMPOS C/ <ENTER>
SET WRAP ON        // NAVEGAO DOS MENUS DO LTIMO PRO PRIMEIRO E VICE-VERSA
SET AUTOPEN OFF    // ABRE AUTOMATICAMENTE OS NDICES COM O MESMO NOME DO DBF

*** SETs (Harbour/xHarbour)
SETMOUSE(.t.)
SET(39,159) // MOUSE NOS GETs
SET TIME FORMAT TO "hh:mm"
SET HARDCOMMIT OFF //  MELHOR DAR UM DBCOMMIT() NO FINAL DE CADA TAREFA
SET OPTIMIZE ON    // OTIMIZA FILTROS NO BANCO DE DADOS

*** CONFIGURAO DA LINGUAGEM PORTUGUS (Harbour/xHarbour)
HB_LangSelect("PT")     // Lngua Portuguesa
HB_SetCodePage("PT850") // CODEPAGE

*** DEFINIR TIPO DE BANCO DE DADOS: DBFCDX Nativo ***
// ANNOUNCE RDDSYS
REQUEST DBFCDX
REQUEST DBFFPT
ANNOUNCE FPTCDX
RDDSETDEFAULT("DBFCDX")
RDDREGISTER( "DBFCDX", 1 ) // RDT_FULL
 
CRIADBF()  // CHAMA ROTINA DE CRIAO DE BANCO DE DADOS
MENU() // CHAMA ROTINA DO MENU PRINCIPAL

FUNCTION MENU()
SETCOLOR("W+/N, N/W,,,W+/BG") // DEFINE COR DA LETRA, SELECIONADO/FOCO, NO SELECIONADO/SEM FOCO.
CLS // COMANDO PARA LIMPAR A TELA: CLear Screen
@ 00,00 TO 02,79 DOUBLE // NOME DO SISTEMA
@ 03,00 TO 05,79 DOUBLE // NOME DO PROGRAMA ATUAL
@ 06,00 TO 23,79 DOUBLE // REA DE TRABALHO
@ 24,00 SAY SPACE(80) COLOR "W+/BG"  // LINHA DE STATUS, MENSAGENS, ALERTAS ETC.
cSISTEMA := "AGENDA TELEFNICA"
cPROGRAMA := "MENU PRINCIPAL"
@ 01,(80-LEN(cSISTEMA))/2  SAY cSISTEMA  // (80 COLUNAS - TAMANHO DA STRING)/2 = MEIO DA TELA
@ 04,(80-LEN(cPROGRAMA))/2 SAY cPROGRAMA 
@ 24,55 SAY "Tecle [Esc] para sair" COLOR "W+/BG"

SETCOLOR("W+/BG")       // PINTA UMA JANELA DE MENU
@ 11,19 CLEAR TO 16,37  // LIMPA ESSA REA
@ 11,19 TO       16,37 DOUBLE // DESENHA UMA MOLDURA DUPLA NELA

nMENU := 1 // DEFINE UMA VARIVEL NUMRICA = 1 PARA ARMAZENAR A ESCOLHA DO USURIO
@ 12,21 PROMPT " 1. Cadastro   " MESSAGE "Cadastra nmero telefnico            "
@ 13,21 PROMPT " 2. Consulta   " MESSAGE "Mostra nmeros cadastrados na agenda  "
@ 14,21 PROMPT " 3. Deleta     " MESSAGE "Deleta nmero cadastrado              "
@ 15,21 PROMPT " 4. Manuteno " MESSAGE "Recria arquivos de ndices            "
MENU TO nMENU
DO CASE
   CASE nMENU = 1
        CADASTRO() // CHAMA SUBROTINA DE CADASTRO
   CASE nMENU = 2
        CONSULTA()  // CHAMA SUBROTINA DE CONSULTA
   CASE nMENU = 3
        DELETA()     // CHAMA SUBROTINA PARA DELETAR REGISTROS
   CASE nMENU = 4
        ERASE("*"+INDEXEXT()) // APAGA TODOS OS ARQUIVOS DE ÍNDICE
        CRIADBF() // CHAMA A FUNO DE CRIAO DE BANCO DE DADOS E NDICES
   OTHERWISE // CASO NENHUMA DAS ANTERIORES
             // QUANDO O USURIO TECLA [Esc] nMENU = 0
        QUIT // ENCERRA O PROGRAMA
ENDCASE
MENU() // CHAMA O MENU NOVAMENTE APS VOLTAR DE OUTRA SUBROTINA (FUNO)

FUNCTION CRIADBF() // CRIA SUBROTINA CHAMADA DBF()
IF .NOT. FILE("AGENDA.DBF") // SE NO EXISTIR O ARQUIVO "AGENDA.DBF"...
   aDBF = {} // CRIA UMA VARIVEL DO TIPO ARRAY (MATRIZ) PARA ARMAZENAR A ESTRUTURA DO BANCO DE DADOS
   AADD(aDBF, {"NOME", "C", 30, 0}) // NOME, TIPO "C" CARACTER, TAMANHO 30, 0 CASAS DECIMAIS.
   AADD(aDBF, {"FONE", "N", 11, 0}) // FONE, TIPO "N" NUMRICO, TAMANHO 11, 0 CASAS DECIMAIS.  
   AADD(aDBF, {"CPF",  "N", 11, 0})  
   DBCREATE("AGENDA.DBF", aDBF) // FUNO QUE CRIA O BANCO DE DADOS COM BASE NUMA VARIVEL ARRAY (MATRIZ)
ENDIF
IF .NOT. FILE( "AGENDA"+INDEXEXT() ) // SE NO EXISTIR O ARQUIVO DE NDICE DA AGENDA...
   USE AGENDA ALIAS FO EXCLUSIVE NEW // ABRE O BANCO DE DADOS AGENDA EM MODO EXCLUSIVO PARA INDEXAR
   INDEX ON NOME TAG NOME TO AGENDA  // CRIA O ARQUIVO DE NDICE INDEXANDO PELO NOME
   INDEX ON FONE TAG FONE TO AGENDA  // CRIA O ARQUIVO DE NDICE INDEXANDO PELO TELEFONE
   INDEX ON CPF  TAG CPF  TO AGENDA  // CRIA O ARQUIVO DE NDICE INDEXANDO PELO CPF
   CLOSE
ENDIF
RETURN

// PARA PODER COMPILAR SEM ERROS TEM QUE DEFINIR AS FUNES
FUNCTION CADASTRO()
USE AGENDA ALIAS AG SHARED NEW // ABRE O BANCO DE DADOS EM MODO COMPARTILHADO
SET INDEX TO AGENDA            // ABRE O ARQUIVO DE NDICE  
AG->(ORDSETFOCUS("CPF"))       // COLOCA ORDENADO POR CPF

SETCOLOR("W+/N")
@ 04,01 SAY PADC("CADASTRO DA AGENDA", 77, " ") // CENTRALIZA DENTRO DE 77 CARACTERES

DO WHILE .T. // CRIA UM LOOP SUPOSTAMENTE INFINITO
    @ 07,01 CLEAR TO 22,78  // LIMPA ESSA REA
    cNOME := SPACE(30) // DEFINE UMA VARIVEL CARACTER TAMANHO 30
	nFONE := 0         // DEFINE TELEFONE NUMRICO
	cCPF  := SPACE(11) // DEFINE CPF CARACTER PORQUE O PONTO DA MSCARA  LIDO COMO DECIMAL
	@ 09,10 SAY "CPF.:" GET cCPF PICTURE "@R 999.999.999-99"             // EXIBE UMA MSCARA NO GET QUE RETORNA 99999999999
	@ 24,00 SAY PADL("Insira um nmero de CPF",54, " ") COLOR "W+/BG"    // MENSAGEM NA LINHA DE STATUS
	READ // AGUARDA A LEITURA DOS GETs

	IF LASTKEY() = K_ESC	   
	   EXIT // SAI DO LOOP
	ELSEIF EMPTY(cCPF) // SE DEIXOU EM BRANCO
		   ALERT("PRECISA DIGITAR O CPF")
		   LOOP        // VOLTA PRA LINHA SEGUINTE AO 'DO WHILE'
	ENDIF   

    nCPF := VAL( cCPF ) // CONVERTE cCPF CARACTER PARA nCPF NUMRICO COM VAL()
	IF AG->(DBSEEK(nCPF)) // SE A PESQUISA DBSEEK() NO DBF RETORNOU .T. (VERDADEIRA)
	   ALERT("ESSA PESSOA J FOI CADASTRADA")
	   LOOP
	ELSE
	   // ROTINA DE CADASTRO
	   // PEDE PRO USURIO DIGITAR O NOME E TELEFONE
	   @ 24,00 SAY PADL("Digite um nome e telefone", 54, " ") COLOR "W+/BG" // NA COLUNA 55 TEM 'TECLE [ESC]'
	   @ 10,10 SAY "NOME:" GET cNOME 
	   @ 11,10 SAY "FONE:" GET nFONE PICTURE "@R (99) 99999-9999"
	   READ	   
	   
	   IF ( ALERT("Confirma cadastro?", {"Sim", "No"}) ) = 1
	      AG->(DBAPPEND())  // INSERE UM REGISTRO EM BRANCO NO ARQUIVO DBF  
	      // GRAVA AS VARIVEIS NOS RESPECTIVOS CAMPOS DO BANCO DE DADOS
		  AG->CPF  := nCPF  
	      AG->NOME := cNOME
	      AG->FONE := nFONE
	      AG->(DBCOMMIT())  // JOGA O CACHE PRO DISCO (GRAVA NO DBF)
	      AG->(DBUNLOCK())  // DESBLOQUEIA O REGISTRO
	   ENDIF
	ENDIF   
ENDDO // VOLTA PRA LINHA SEGUINTE DO 'DO WHILE'

AG->(DBCLOSEAREA()) // FECHA O BANCO DE DADOS
RETURN // RETORNA PRA FUNCO QUE CHAMOU CADASTRO()

FUNCTION CONSULTA()
USE AGENDA ALIAS AG SHARED NEW // ABRE O BANCO DE DADOS EM MODO COMPARTILHADO
SET INDEX TO AGENDA            // ABRE O ARQUIVO DE NDICE  
SET ORDER TO TAG NOME          // COLOCA ORDENADO POR CPF

SETCOLOR("W+/N")
@ 04,01 SAY PADC("CONSULTA AGENDA", 77, " ") // CENTRALIZA DENTRO DE 77 CARACTERES
@ 07,01 CLEAR TO 22,78                       // LIMPA ESSA REA
@ 24,55 SAY "Tecle [Esc] para sair" COLOR "W+/BG"

aDADOS   := { "NOME", "FONE"              , "AG->(STR(CPF,11))" }
aPICTURE := {       , "@R (99) 99999-9999", "@R 999.999.999-99" }
aTITLES  := {"NOME" , "TELEFONE"          , "CPF"               } 
AG->(DBEDIT(08,02,22,77, aDADOS,,aPICTURE, aTITLES))

AG->(DBCLOSEAREA())

RETURN

FUNCTION DELETA()
	USE AGENDA ALIAS AG SHARED NEW // ABRE O BANCO DE DADOS EM MODO COMPARTILHADO
	SET INDEX TO AGENDA            // ABRE O ARQUIVO DE NDICE  
	AG->(ORDSETFOCUS("CPF"))       // COLOCA ORDENADO POR CPF
	
	SETCOLOR("W+/N")
	@ 04,01 SAY PADC("APAGAR REGISTRO DA AGENDA", 77, " ") // CENTRALIZA DENTRO DE 77 CARACTERES
	
	DO WHILE .T. // CRIA UM LOOP SUPOSTAMENTE INFINITO
		@ 07,01 CLEAR TO 22,78  // LIMPA ESSA REA
		
		cCPF  := SPACE(11) // DEFINE CPF CARACTER PORQUE O PONTO DA MSCARA  LIDO COMO DECIMAL
		@ 09,10 SAY "CPF.:" GET cCPF PICTURE "@R 999.999.999-99"     // EXIBE UMA MSCARA NO GET QUE RETORNA 99999999999
		@ 24,00 SAY PADL("Insira um nmero de CPF para pesquisar",54, " ") COLOR "W+/BG"  // MENSAGEM NA LINHA DE STATUS
		READ // AGUARDA A LEITURA DOS GETs
	
		IF LASTKEY() = K_ESC	   
		   EXIT // SAI DO LOOP
		ELSEIF EMPTY(cCPF) // SE DEIXOU EM BRANCO
			   ALERT("PRECISA DIGITAR O CPF")
			   LOOP        // VOLTA PRA LINHA SEGUINTE AO 'DO WHILE'
		ENDIF   
	
		nCPF := VAL( cCPF ) // CONVERTE cCPF CARACTER PARA nCPF NUMRICO COM VAL()
		IF !AG->(DBSEEK(nCPF)) // SE A PESQUISA DBSEEK()  'NO VERDADEIRA', OU SEJA, FALSA, NO ENCONTROU NADA.
		   ALERT("ESSA PESSOA NO EST CADASTRADA")
		   LOOP
		ELSE
		   // REGISTRO FOI ENCONTRADO, MOSTRA DADOS NA TELA E PEDE CONFIRMAO PARA APAGAR
		   cSN := " " // DEFINE A VARIVEL cSN COMO STRING VAZIA DE 1 CARACTER
		   @ 10,10 SAY "NOME: " + AG->NOME 
		   @ 11,10 SAY "FONE: " + TRANSFORM(AG->FONE, "@R (99) 99999-9999") // ESSA FUNO TRABALHA IGUAL AO PICTURE DO @...GET
		   @ 24,00 SAY SPACE(79) COLOR "W+/BG" // LIMPA A LINHA DE STATUS
		   @ 24,00 SAY "Confirma deletar o registro? (S/N):" COLOR "W+/BG" GET cSN COLOR "GR+/N" PICTURE "@!" VALID cSN $ "SN" 
		   READ
		   
		   // MAIORES DETALHES SOBRE O @...GET ACIMA
		   // PICTURE "@!": Significa que tudo o que for digitado ser MAISCULO
		   // VALID cSN $ "SN": Valida o campo GET se cSN est contido na string "SN", s sai se o usurio pressionar "S" ou "N".
		   		   
		   IF cSN = "S"        // SE DIGITOU "S"
			  AG->(RLOCK())    // BLOQUEIA O REGISTRO
			  AG->(DBDELETE()) // MARCA O REGISTRO PARA DELEO, DELETA ELE.
			  AG->(DBUNLOCK()) // DESBLOQUEIA O REGISTRO
		   ENDIF
		ENDIF   
	ENDDO // VOLTA PRA LINHA SEGUINTE DO 'DO WHILE'
	
	AG->(DBCLOSEAREA()) // FECHA O BANCO DE DADOS
RETURN